﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Collections.ObjectModel;
using Telerik.Windows.Controls;
using Telerik.Windows.Data;
using System.Windows.Data;

namespace HierarchyChildTemplateCustomization
{
    public partial class Page : UserControl
    {
        public Page()
        {
            InitializeComponent();
            GridViewTableDefinition definition = new GridViewTableDefinition();
            definition.Relation = new PropertyRelation("Addresses");

            GridViewDataColumn streetDetailsColumn = new GridViewDataColumn();
            streetDetailsColumn.HeaderText = "Details";
            streetDetailsColumn.DataMemberBinding = new Binding("StreetDetails");
            definition.FieldDescriptors.Add(streetDetailsColumn);

            this.MasterGridView.ChildTableDefinitions.Add(definition);

            this.MasterGridView.ItemsSource = this.CreatePersonsList();
        }

        private ObservableCollection<Person> CreatePersonsList()
        {
            var persons = new ObservableCollection<Person>();
            persons.Add(new Person
            {
                FirstName = "John",
                LastName = "Doe",
                Addresses = new ObservableCollection<Address>
                {
                    new Address
                    {
                        Country = "UK",
                        City = "London",
                        StreetDetails = "5 Google st."
                    },
                    new Address
                    {
                        Country = "UK",
                        City = "London",
                        StreetDetails = "5 Halley st."
                    },
                }
            });
            persons.Add(new Person
            {
                FirstName = "Jane",
                LastName = "Smith",
                Addresses = new ObservableCollection<Address>
                {
                    new Address
                    {
                        Country = "UK",
                        City = "London",
                        StreetDetails = "5 Google st."
                    },
                    new Address
                    {
                        Country = "UK",
                        City = "London",
                        StreetDetails = "5 Halley st."
                    },
                }
            });
            persons.Add(new Person
            {
                FirstName = "John",
                LastName = "Smith",
                Addresses = new ObservableCollection<Address>
                {
                    new Address
                    {
                        Country = "UK",
                        City = "London",
                        StreetDetails = "5 Google st."
                    },
                    new Address
                    {
                        Country = "UK",
                        City = "London",
                        StreetDetails = "5 Halley st."
                    },
                }
            });
            return persons;
        }
    }
}
